214 lines
4.8 KiB
Python
214 lines
4.8 KiB
Python
import cadquery as cq
|
|
from cadquery import exporters
|
|
|
|
import audio_plug
|
|
import battery_holder
|
|
import hdmi_out
|
|
import keyboard
|
|
import screen_pillars
|
|
import usb_hub
|
|
import zero_holder as cpu_holder
|
|
|
|
# Base for the notebook. Basically a kbd base that extends back
|
|
# as much as possible
|
|
|
|
# Thickness of the outer material
|
|
shell_t = 3
|
|
|
|
# Size of the kbd board
|
|
kbd_height = 95.5
|
|
kbd_width = 305
|
|
kbd_angle = 5
|
|
|
|
# Size of the whole object
|
|
width = kbd_width + 2 * shell_t
|
|
height = 159
|
|
thickness = 27 + shell_t # 27 inside
|
|
|
|
# Insert Positions
|
|
ti_radius = 2.35
|
|
ti_depth = 6.25
|
|
|
|
# These are placed where convenient, and are used to join the top and bottom
|
|
# parts of the case.
|
|
# Measured from top-left corner OUTSIDE
|
|
mounting_pillar_positions = [
|
|
(6, 6),
|
|
(6, 48),
|
|
(120, 6),
|
|
(170, 6),
|
|
(width - 6, 6),
|
|
(width - 6, 30),
|
|
(120, 48),
|
|
(170, 48),
|
|
]
|
|
screen_pillars.init(mounting_pillar_positions, thickness - shell_t)
|
|
|
|
# Thing to "grab" the hub so it stays in place
|
|
# Distance from left edge to center of USB plug
|
|
usb_offset = width - 48
|
|
|
|
|
|
# CPU holder position from back-left corner of the case
|
|
cpu_offset_x = 180
|
|
cpu_offset_y = 3
|
|
|
|
# Battery holder position from back-left corner of the case
|
|
battery_offset_x = 15
|
|
battery_offset_y = 3
|
|
|
|
# Offset for the USB port from back-right corner of the case
|
|
usb_offset = 48
|
|
|
|
|
|
def model():
|
|
# Create the basic shape of the case bottom.
|
|
model = (
|
|
cq.Workplane("XY")
|
|
.workplane(offset=thickness / 2)
|
|
.tag("mid_height")
|
|
# Hollow box
|
|
.box(width, height, thickness)
|
|
.edges("|Z")
|
|
.fillet(2)
|
|
.faces(">Z")
|
|
.shell(-shell_t)
|
|
)
|
|
|
|
# Now the basic box shape is in place, start adding things
|
|
# and cutting holes.
|
|
|
|
model = usb_hub.add(
|
|
model=model,
|
|
width=width,
|
|
height=height,
|
|
thickness=thickness,
|
|
bottom_face="<Z",
|
|
back_face=">Y",
|
|
offset_x=width - usb_offset,
|
|
offset_y=0,
|
|
shell_t=shell_t,
|
|
)
|
|
|
|
# Hole for audio in right side
|
|
model = audio_plug.add(
|
|
model=model,
|
|
width=width,
|
|
height=height,
|
|
thickness=thickness,
|
|
offset_x=111, # Offset from the front-left corner
|
|
offset_y=0, # Offset from the bottom
|
|
bottom_face=None,
|
|
back_face=">X",
|
|
shell_t=shell_t,
|
|
)
|
|
|
|
# Hole for HDMI out in the back
|
|
model = hdmi_out.add(
|
|
model=model,
|
|
width=width,
|
|
height=height,
|
|
thickness=thickness,
|
|
offset_x=138,
|
|
offset_y=0,
|
|
bottom_face=None,
|
|
back_face=">Y",
|
|
shell_t=shell_t,
|
|
)
|
|
|
|
model = cpu_holder.add(
|
|
model=model,
|
|
width=width,
|
|
height=height,
|
|
thickness=thickness,
|
|
offset_x=cpu_offset_x,
|
|
offset_y=cpu_offset_y,
|
|
bottom_face="<Z",
|
|
back_face=None, # Not exposing the holes
|
|
shell_t=shell_t,
|
|
)
|
|
|
|
# This adds all the holes and extrusions for the battery system
|
|
model = battery_holder.add(
|
|
model=model,
|
|
width=width,
|
|
height=height,
|
|
thickness=thickness,
|
|
offset_x=battery_offset_x,
|
|
offset_y=battery_offset_y,
|
|
bottom_face="<Z",
|
|
back_face=">Y",
|
|
shell_t=shell_t,
|
|
)
|
|
|
|
model = screen_pillars.add(
|
|
model=model,
|
|
width=width,
|
|
height=height,
|
|
thickness=thickness,
|
|
offset_x=0,
|
|
offset_y=0,
|
|
bottom_face="<Z",
|
|
back_face=None,
|
|
shell_t=shell_t,
|
|
)
|
|
|
|
model = keyboard.add(
|
|
model=model,
|
|
width=width,
|
|
height=height,
|
|
thickness=thickness,
|
|
bottom_face="<Z",
|
|
back_face=None,
|
|
offset_x=shell_t,
|
|
offset_y=kbd_height + shell_t,
|
|
shell_t=shell_t,
|
|
)
|
|
|
|
return model
|
|
|
|
|
|
if __name__ == "__main__":
|
|
|
|
model = model()
|
|
|
|
left_cutout = cq.Sketch().polygon(
|
|
[(0, 0), (width / 2, 0), (width / 2, -height), (0, -height), (0, 0)],
|
|
mode="a",
|
|
)
|
|
|
|
right_side = (
|
|
model.faces("<Z")
|
|
.workplaneFromTagged("mid_height")
|
|
.transformed(offset=cq.Vector(0, 0, -thickness / 2))
|
|
.center(-width / 2, height / 2)
|
|
.placeSketch(left_cutout)
|
|
.cutBlind(100)
|
|
)
|
|
|
|
exporters.export(right_side, "right_side.stl")
|
|
|
|
right_cutout = cq.Sketch().polygon(
|
|
[
|
|
(width / 2, 0),
|
|
(width, 0),
|
|
(width, -height),
|
|
(width / 2, -height),
|
|
(width / 2, 0),
|
|
],
|
|
mode="a",
|
|
)
|
|
|
|
left_side = (
|
|
model.faces("<Z")
|
|
.workplaneFromTagged("mid_height")
|
|
.transformed(offset=cq.Vector(0, 0, -thickness / 2))
|
|
.center(-width / 2, height / 2)
|
|
.placeSketch(right_cutout)
|
|
.cutBlind(100)
|
|
)
|
|
exporters.export(left_side, "left_side.stl")
|
|
|
|
exporters.export(model, "model.stl")
|
|
exporters.export(model, "model.svg", opt={"projectionDir": (0, 0, 1)})
|